<?php


/****************************************************
 *
 * @File:  groupdocs_viewer_dotnet.php
 * @Action:  Provides groupdocs viewer dotnet shortcode
 *
 *****************************************************/
$viewer_dotnet_tags   = array();  // Shortcode tags array
$viewer_dotnet_info   = array();  // Shortcode tags info array

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
    $thisfile, 				# ID of plugin, should be filename minus php
    'GroupDocs.Viewer for .Net',			 	# Title of plugin
    '1.0.0', 				# Version of plugin
    'GroupDocs Marketplace Team',				# Author of plugin
    'http://www.groupdocs.com/', 		# Author URL
    'This plugin is developed based on the GroupDocs HTML5 document viewer for .NET library, which enables you to display over 45 different types of documents right on your GetSimple website.', 			# Plugin Description
    'plugins' 				# Page type of plugin
);

# activate hooks
//add_action('plugins-sidebar','createSideMenu',array($thisfile,'Shortcode Info'));
if (get_filename_id()=="edit"){
    add_action('edit-extras','insertViewerDotNetButton',array());
}

function insertViewerDotNetButton(){
    echo "<script type=\"text/javascript\">";
    echo "jQuery(document).ready(function() { ";

    echo "$(\"<input class=submit id=gdviewerdotnet type=button value='GD DotNet Viewer' />\").insertAfter($('#metadata_window'));";
    ?>

    $("#gdviewerdotnet").on("click", function(){
    var selectedText = CKEDITOR.instances["post-content"].getSelection().getSelectedText();
    var tag= "[GDDotNetViewer server='url' width='1200' height='650' /]";
    if (selectedText!='') {
    tag = tag.replace('url',selectedText);
    }
    CKEDITOR.instances["post-content"].insertText(tag);
    })

    <?php
    echo " })";
    echo "</script>";

}


/*
 * @uses $viewer_tags,$viewer_info
 *
 * @param string $tag Shortcode tag to be searched in post content.
 * @param callable $func Hook to run when shortcode is found.
 * @param string $desc , the desription of the shortcode
 */
function gdvd_shortcode($tag, $func, $desc="Default Description") {

    global $viewer_dotnet_tags;
    global $viewer_dotnet_info;
    if ( is_callable($func) )
        $viewer_dotnet_tags[(string)$tag] = $func;
    $viewer_dotnet_info[(string)$tag] = $desc;

}


/**
 * Search content for groupdocs shortcode and alter shortcodes through it's hook.
 *
 * If there are no shortcode tags defined, then the content will be returned
 * without any filtering.
 *
 * @uses $viewer_tags
 * @uses gdv_get_shortcode_regex() Gets the search pattern for searching shortcodes.
 *
 * @param string $content Content to search for shortcodes
 * @return string Content with shortcodes filtered out.
 */
function gdvd_do_shortcode($content) {
    global $viewer_dotnet_tags;

    if (empty($viewer_dotnet_tags) || !is_array($viewer_dotnet_tags))
        return $content;

    $tagnames = array_keys($viewer_dotnet_tags);
    $tagregexp = join( '|', array_map('preg_quote', $tagnames) );

    $removeTagsPattern = '/(\s*)(<p>\s*)(\[('.$tagregexp.')\b(.*?)(?:(\/))?\])(?:(.+?)\[\/\2\])?(.?)(\s*<\/p>)/';

    $content2 = preg_replace($removeTagsPattern, '$3 ', $content) ;

    $pattern = gdvd_get_shortcode_regex();
    return preg_replace_callback('/'.$pattern.'/s', 'gdvd_do_shortcode_tag', htmlspecialchars_decode($content2));
}

/**
 * Retrieve the shortcode regular expression for searching.
 *
 * The regular expression combines the shortcode tags in the regular expression
 * in a regex class.
 *
 * The regular expresion contains 6 different sub matches to help with parsing.
 *
 * 1/6 - An extra [ or ] to allow for escaping shortcodes with double [[]]
 * 2 - The shortcode name
 * 3 - The shortcode argument list
 * 4 - The self closing /
 * 5 - The content of a shortcode when it wraps some content.
 *
 * @uses $viewer_tags
 *
 * @return string The shortcode search regular expression
 */
function gdvd_get_shortcode_regex() {
    global $viewer_dotnet_tags;
    $tagnames = array_keys($viewer_dotnet_tags);
    $tagregexp = join( '|', array_map('preg_quote', $tagnames) );

    // WARNING! Do not change this regex without changing gdv_do_shortcode_tag() and gdvd_strip_shortcodes()
    return '(.?)\[('.$tagregexp.')\b(.*?)(?:(\/))?\](?:(.+?)\[\/\2\])?(.?)';
}

/**
 * Regular Expression callable for gdv_do_shortcode() for calling shortcode hook.
 * @see gdv_get_shortcode_regex for details of the match array contents.
 *
 * @access private
 * @uses $viewer_tags
 *
 * @param array $m Regular expression match array
 * @return mixed False on failure.
 */
function gdvd_do_shortcode_tag( $m ) {
    global $viewer_dotnet_tags;

    // allow [[foo]] syntax for escaping a tag
    if ( $m[1] == '[' && $m[6] == ']' ) {
        return substr($m[0], 1, -1);
    }

    $tag = $m[2];
    $attr = gdvd_shortcode_parse_atts( $m[3] );

    if ( isset( $m[5] ) ) {
        // enclosing tag - extra parameter
        return $m[1] . call_user_func( $viewer_dotnet_tags[$tag], $attr, $m[5], $tag ) . $m[6];
    } else {
        // self-closing tag
        return $m[1] . call_user_func( $viewer_dotnet_tags[$tag], $attr, NULL,  $tag ) . $m[6];
    }
}

/**
 * Retrieve all attributes from the shortcodes tag.
 *
 * The attributes list has the attribute name as the key and the value of the
 * attribute as the value in the key/value pair. This allows for easier
 * retrieval of the attributes, since all attributes have to be known.
 *
 *
 * @param string $text
 * @return array List of attributes and their value.
 */
function gdvd_shortcode_parse_atts($text) {
    $atts = array();
    $pattern = '/(\w+)\s*=\s*"([^"]*)"(?:\s|$)|(\w+)\s*=\s*\'([^\']*)\'(?:\s|$)|(\w+)\s*=\s*([^\s\'"]+)(?:\s|$)|"([^"]*)"(?:\s|$)|(\S+)(?:\s|$)/';
    $text = preg_replace("/[\x{00a0}\x{200b}]+/u", " ", $text);
    if ( preg_match_all($pattern, $text, $match, PREG_SET_ORDER) ) {
        foreach ($match as $m) {
            if (!empty($m[1]))
                $atts[strtolower($m[1])] = stripcslashes($m[2]);
            elseif (!empty($m[3]))
                $atts[strtolower($m[3])] = stripcslashes($m[4]);
            elseif (!empty($m[5]))
                $atts[strtolower($m[5])] = stripcslashes($m[6]);
            elseif (isset($m[7]) and strlen($m[7]))
                $atts[] = stripcslashes($m[7]);
            elseif (isset($m[8]))
                $atts[] = stripcslashes($m[8]);
        }
    } else {
        $atts = ltrim($text);
    }
    return $atts;
}

/**
 * Combine user attributes with known attributes and fill in defaults when needed.
 *
 * The pairs should be considered to be all of the attributes which are
 * supported by the caller and given as a list. The returned attributes will
 * only contain the attributes in the $pairs list.
 *
 * If the $atts list has unsupported attributes, then they will be ignored and
 * removed from the final returned list.
 *
 *
 * @param array $pairs Entire list of supported attributes and their defaults.
 * @param array $atts User defined attributes in shortcode tag.
 * @return array Combined and filtered attribute list.
 */
function gdvd_shortcode_atts($pairs, $atts) {
    $atts = (array)$atts;
    $out = array();

    foreach($pairs as $name => $default) {
        if ( array_key_exists($name, $atts) )
            $out[$name] = $atts[$name];
        else
            $out[$name] = $default;
    }
    return $out;
}

/**
 * Remove all shortcode tags from the given content.
 *
 * @uses $viewer_tags
 *
 * @param string $content Content to remove shortcode tags.
 * @return string Content without shortcode tags.
 */
function gdvd_strip_shortcodes( $content ) {
    global $viewer_dotnet_tags;

    if (empty($viewer_dotnet_tags) || !is_array($viewer_dotnet_tags))
        return $content;

    $pattern = gdvd_get_shortcode_regex();

    return preg_replace('/'.$pattern.'/s', '$1$6', $content);
}



function gdvd_output_shortcode($data){
    $ret=gdvd_do_shortcode($data);
    echo $ret;
}

include GSPLUGINPATH.'groupdocs_viewer_dotnet/shortcode.php';

if (file_exists(GSTHEMESPATH .$TEMPLATE.'/shortcode.php')){
    include GSTHEMESPATH.$TEMPLATE.'/shortcode.php';

}

add_filter('content','gdvd_do_shortcode');
?>
